# Class ApplicationContextFacade

java.lang.Object
org.apache.catalina.core.ApplicationContextFacade

All Implemented Interfaces:
  `ServletContext`

public class ApplicationContextFacade extends Object implements ServletContext
Facade object which masks the internal `ApplicationContext` object from the web application.

## Field Summary

### Fields inherited from interface ServletContext

`ORDERED_LIBS, TEMPDIR`

## Constructor Summary

Constructors
Constructor
Description
`ApplicationContextFacade(ApplicationContext context)`
Construct a new instance of this class, associated with the specified Context instance.

## Method Summary

Modifier and Type
Method
Description
`FilterRegistration.Dynamic`
`addFilter(String filterName, Filter filter)`
Add filter to context.
`FilterRegistration.Dynamic`
`addFilter(String filterName, Class<? extends Filter> filterClass)`
Add filter to context.
`FilterRegistration.Dynamic`
`addFilter(String filterName, String className)`
Add filter to context.
`ServletRegistration.Dynamic`
`addJspFile(String jspName, String jspFile)`
Add a JSP to the context.
`void`
`addListener(Class<? extends EventListener> listenerClass)`
Adds a listener to this web application.
`void`
`addListener(String className)`
Adds a listener to this web application.
`<T extends EventListener>
void`
`addListener(T t)`
Adds the given listener instance to this web application.
`ServletRegistration.Dynamic`
`addServlet(String servletName, Servlet servlet)`
Register a servlet instance for use in this ServletContext.
`ServletRegistration.Dynamic`
`addServlet(String servletName, Class<? extends Servlet> servletClass)`
Add servlet to the context.
`ServletRegistration.Dynamic`
`addServlet(String servletName, String className)`
Register a servlet implementation for use in this ServletContext.
`<T extends Filter>
T`
`createFilter(Class<T> c)`
Create a Filter instance using the given class.
`<T extends EventListener>
T`
`createListener(Class<T> c)`
Creates a new instance of the given listener class, using the web application class loader.
`<T extends Servlet>
T`
`createServlet(Class<T> c)`
Create an Servlet instance using the given class.
`void`
`declareRoles(String... roleNames)`
Add to the declared roles for this ServletContext.
`Object`
`getAttribute(String name)`
Returns the servlet container attribute with the given name, or `null` if there is no attribute by that name.
`Enumeration<String>`
`getAttributeNames()`
Returns an `Enumeration` containing the attribute names available within this servlet context.
`ClassLoader`
`getClassLoader()`
Get the web application class loader associated with this ServletContext.
`ServletContext`
`getContext(String uripath)`
Returns a `ServletContext` object that corresponds to a specified URL on the server.
`String`
`getContextPath()`
Return the main path associated with this context.
`Set<SessionTrackingMode>`
`getDefaultSessionTrackingModes()`
Obtains the default session tracking modes for this web application.
`int`
`getEffectiveMajorVersion()`
Obtain the major version of the servlet specification for which this web application is implemented.
`int`
`getEffectiveMinorVersion()`
Obtain the minor version of the servlet specification for which this web application is implemented.
`Set<SessionTrackingMode>`
`getEffectiveSessionTrackingModes()`
Obtains the currently enabled session tracking modes for this web application.
`FilterRegistration`
`getFilterRegistration(String filterName)`
Returns the `FilterRegistration` for the given filter, or `null` if no such filter exists.
`Map<String, ? extends FilterRegistration>`
`getFilterRegistrations()`
Returns an immutable Map of all the filter registrations for this web application, where the key is the filter name and the value is the `FilterRegistration` object.
`String`
`getInitParameter(String name)`
Returns a `String` containing the value of the named context-wide initialization parameter, or `null` if the parameter does not exist.
`Enumeration<String>`
`getInitParameterNames()`
Returns the names of the context's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the context has no initialization parameters.
`JspConfigDescriptor`
`getJspConfigDescriptor()`
Returns the `JspConfigDescriptor` for this web application, which provides access to the JSP configuration elements such as taglib and jsp-property-group declarations.
`int`
`getMajorVersion()`
Returns the major version of the Java Servlet API that this servlet container supports.
`String`
`getMimeType(String file)`
Returns the MIME type of the specified file, or `null` if the MIME type is not known.
`int`
`getMinorVersion()`
Returns the minor version of the Servlet API that this servlet container supports.
`RequestDispatcher`
`getNamedDispatcher(String name)`
Returns a `RequestDispatcher` object that acts as a wrapper for the named servlet.
`String`
`getRealPath(String path)`
Returns a `String` containing the real path for a given virtual path.
`String`
`getRequestCharacterEncoding()`
Get the default character encoding for reading request bodies.
`RequestDispatcher`
`getRequestDispatcher(String path)`
Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path.
`URL`
`getResource(String path)`
Returns a URL to the resource that is mapped to a specified path.
`InputStream`
`getResourceAsStream(String path)`
Returns the resource located at the named path as an `InputStream` object.
`Set<String>`
`getResourcePaths(String path)`
Returns a directory-like listing of all the paths to resources within the web application whose longest sub-path matches the supplied path argument.
`String`
`getResponseCharacterEncoding()`
Get the default character encoding for writing response bodies.
`String`
`getServerInfo()`
Returns the name and version of the servlet container on which the servlet is running.
`String`
`getServletContextName()`
Returns the name of this web application corresponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.
`ServletRegistration`
`getServletRegistration(String servletName)`
Obtain the details of the named servlet.
`Map<String, ? extends ServletRegistration>`
`getServletRegistrations()`
Obtain a Map of servlet names to servlet registrations for all servlets registered with this context.
`SessionCookieConfig`
`getSessionCookieConfig()`
Returns the `SessionCookieConfig` object for this web application, which can be used to configure the session tracking cookie.
`int`
`getSessionTimeout()`
Get the default session timeout.
`String`
`getVirtualServerName()`
Get the primary name of the virtual host on which this context is deployed.
`void`
`log(String msg)`
Writes the specified message to a servlet log file, usually an event log.
`void`
`log(String message, Throwable throwable)`
Writes an explanatory message and a stack trace for a given `Throwable` exception to the servlet log file.
`void`
`removeAttribute(String name)`
Removes the attribute with the given name from the servlet context.
`void`
`setAttribute(String name, Object object)`
Binds an object to a given attribute name in this servlet context.
`boolean`
`setInitParameter(String name, String value)`
Set the given initialisation parameter to the given value.
`void`
`setRequestCharacterEncoding(String encoding)`
Set the default character encoding to use for reading request bodies.
`void`
`setResponseCharacterEncoding(String encoding)`
Set the default character encoding to use for writing response bodies.
`void`
`setSessionTimeout(int sessionTimeout)`
Set the default session timeout.
`void`
`setSessionTrackingModes(Set<SessionTrackingMode> sessionTrackingModes)`
Configures the available session tracking modes for this web application.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ApplicationContextFacade

public ApplicationContextFacade(ApplicationContext context)
Construct a new instance of this class, associated with the specified Context instance.

Parameters:
  `context` - The associated Context instance

## Method Details

### getContext

public ServletContext getContext(String uripath)
Description copied from interface: `jakarta.servlet.ServletContext`
Returns a `ServletContext` object that corresponds to a specified URL on the server.

This method allows servlets to gain access to the context for various parts of the server, and as needed obtain `RequestDispatcher` objects from the context. The given path must be begin with "/", is interpreted relative to the server's document root and is matched against the context roots of other web applications hosted on this container.

In a security conscious environment, the servlet container may return `null` for a given URL.

Specified by:
  `getContext` in interface `ServletContext`
Parameters:
  `uripath` - a `String` specifying the context path of another web application in the container.
Returns:
  the `ServletContext` object that corresponds to the named URL, or null if either none exists or the container wishes to restrict this access.
See Also:
  - `RequestDispatcher`

### getMajorVersion

public int getMajorVersion()
Description copied from interface: `jakarta.servlet.ServletContext`
Returns the major version of the Java Servlet API that this servlet container supports. All implementations that comply with Version 6.0 must have this method return the integer 6.

Specified by:
  `getMajorVersion` in interface `ServletContext`
Returns:
  6

### getMinorVersion

public int getMinorVersion()
Description copied from interface: `jakarta.servlet.ServletContext`
Returns the minor version of the Servlet API that this servlet container supports. All implementations that comply with Version 6.0 must have this method return the integer 0.

Specified by:
  `getMinorVersion` in interface `ServletContext`
Returns:
  0

### getMimeType

public String getMimeType(String file)
Description copied from interface: `jakarta.servlet.ServletContext`
Returns the MIME type of the specified file, or `null` if the MIME type is not known. The MIME type is determined by the configuration of the servlet container, and may be specified in a web application deployment descriptor. Common MIME types are `"text/html"` and `"image/gif"`.

Specified by:
  `getMimeType` in interface `ServletContext`
Parameters:
  `file` - a `String` specifying the name of a file
Returns:
  a `String` specifying the file's MIME type

### getResourcePaths

public Set<String> getResourcePaths(String path)
Description copied from interface: `jakarta.servlet.ServletContext`
Returns a directory-like listing of all the paths to resources within the web application whose longest sub-path matches the supplied path argument. Paths indicating subdirectory paths end with a '/'. The returned paths are all relative to the root of the web application and have a leading '/'. For example, for a web application containing
/welcome.html
/catalog/index.html
/catalog/products.html
/catalog/offers/books.html
/catalog/offers/music.html
/customer/login.jsp
/WEB-INF/web.xml
/WEB-INF/classes/com.acme.OrderServlet.class,
getResourcePaths("/") returns {"/welcome.html", "/catalog/", "/customer/", "/WEB-INF/"}
getResourcePaths("/catalog/") returns {"/catalog/index.html", "/catalog/products.html", "/catalog/offers/"}.

Specified by:
  `getResourcePaths` in interface `ServletContext`
Parameters:
  `path` - the partial path used to match the resources, which must start with a /
Returns:
  a Set containing the directory listing, or null if there are no resources in the web application whose path begins with the supplied path.

### getResource

public URL getResource(String path) throws MalformedURLException
Description copied from interface: `jakarta.servlet.ServletContext`
Returns a URL to the resource that is mapped to a specified path. The path must begin with a "/" and is interpreted as relative to the current context root.

This method allows the servlet container to make a resource available to servlets from any source. Resources can be located on a local or remote file system, in a database, or in a `.war` file.

The servlet container must implement the URL handlers and `URLConnection` objects that are necessary to access the resource.

This method returns `null` if no resource is mapped to the pathname.

Some containers may allow writing to the URL returned by this method using the methods of the URL class.

The resource content is returned directly, so be aware that requesting a `.jsp` page returns the JSP source code. Use a `RequestDispatcher` instead to include results of an execution.

This method has a different purpose than `java.lang.Class.getResource`, which looks up resources based on a class loader. This method does not use class loaders.

Specified by:
  `getResource` in interface `ServletContext`
Parameters:
  `path` - a `String` specifying the path to the resource
Returns:
  the resource located at the named path, or `null` if there is no resource at that path
Throws:
  `MalformedURLException` - if the pathname is not given in the correct form

### getResourceAsStream

public InputStream getResourceAsStream(String path)
Description copied from interface: `jakarta.servlet.ServletContext`
Returns the resource located at the named path as an `InputStream` object.

The data in the `InputStream` can be of any type or length. The path must be specified according to the rules given in `getResource`. This method returns `null` if no resource exists at the specified path.

Meta-information such as content length and content type that is available via `getResource` method is lost when using this method.

The servlet container must implement the URL handlers and `URLConnection` objects necessary to access the resource.

This method is different from `java.lang.Class.getResourceAsStream`, which uses a class loader. This method allows servlet containers to make a resource available to a servlet from any location, without using a class loader.

Specified by:
  `getResourceAsStream` in interface `ServletContext`
Parameters:
  `path` - a `String` specifying the path to the resource
Returns:
  the `InputStream` returned to the servlet, or `null` if no resource exists at the specified path

### getRequestDispatcher

public RequestDispatcher getRequestDispatcher(String path)
Description copied from interface: `jakarta.servlet.ServletContext`
Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path. A `RequestDispatcher` object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

The pathname must begin with a "/" and is interpreted as relative to the current context root. Use `getContext` to obtain a `RequestDispatcher` for resources in foreign contexts. This method returns `null` if the `ServletContext` cannot return a `RequestDispatcher`.

Specified by:
  `getRequestDispatcher` in interface `ServletContext`
Parameters:
  `path` - a `String` specifying the pathname to the resource
Returns:
  a `RequestDispatcher` object that acts as a wrapper for the resource at the specified path, or `null` if the `ServletContext` cannot return a `RequestDispatcher`
See Also:
  - `RequestDispatcher`
  - `ServletContext.getContext(String)`

### getNamedDispatcher

public RequestDispatcher getNamedDispatcher(String name)
Description copied from interface: `jakarta.servlet.ServletContext`
Returns a `RequestDispatcher` object that acts as a wrapper for the named servlet.

Servlets (and JSP pages also) may be given names via server administration or via a web application deployment descriptor. A servlet instance can determine its name using `ServletConfig.getServletName()`.

This method returns `null` if the `ServletContext` cannot return a `RequestDispatcher` for any reason.

Specified by:
  `getNamedDispatcher` in interface `ServletContext`
Parameters:
  `name` - a `String` specifying the name of a servlet to wrap
Returns:
  a `RequestDispatcher` object that acts as a wrapper for the named servlet, or `null` if the `ServletContext` cannot return a `RequestDispatcher`
See Also:
  - `RequestDispatcher`
  - `ServletContext.getContext(String)`
  - `ServletConfig.getServletName()`

### log

public void log(String msg)
Description copied from interface: `jakarta.servlet.ServletContext`
Writes the specified message to a servlet log file, usually an event log. The name and type of the servlet log file is specific to the servlet container.

Specified by:
  `log` in interface `ServletContext`
Parameters:
  `msg` - a `String` specifying the message to be written to the log file

### log

public void log(String message, Throwable throwable)
Description copied from interface: `jakarta.servlet.ServletContext`
Writes an explanatory message and a stack trace for a given `Throwable` exception to the servlet log file. The name and type of the servlet log file is specific to the servlet container, usually an event log.

Specified by:
  `log` in interface `ServletContext`
Parameters:
  `message` - a `String` that describes the error or exception
  `throwable` - the `Throwable` error or exception

### getRealPath

public String getRealPath(String path)
Description copied from interface: `jakarta.servlet.ServletContext`
Returns a `String` containing the real path for a given virtual path. For example, the path "/index.html" returns the absolute file path on the server's filesystem would be served by a request for "http://host/contextPath/index.html", where contextPath is the context path of this ServletContext..

The real path returned will be in a form appropriate to the computer and operating system on which the servlet container is running, including the proper path separators. This method returns `null` if the servlet container cannot translate the virtual path to a real path for any reason (such as when the content is being made available from a `.war` archive).

Specified by:
  `getRealPath` in interface `ServletContext`
Parameters:
  `path` - a `String` specifying a virtual path
Returns:
  a `String` specifying the real path, or null if the translation cannot be performed

### getServerInfo

public String getServerInfo()
Description copied from interface: `jakarta.servlet.ServletContext`
Returns the name and version of the servlet container on which the servlet is running.

The form of the returned string is servername/versionnumber. For example, the JavaServer Web Development Kit may return the string `JavaServer Web Dev Kit/1.0`.

The servlet container may return other optional information after the primary string in parentheses, for example, `JavaServer Web Dev Kit/1.0 (JDK 1.1.6; Windows NT 4.0 x86)`.

Specified by:
  `getServerInfo` in interface `ServletContext`
Returns:
  a `String` containing at least the servlet container name and version number

### getInitParameter

public String getInitParameter(String name)
Description copied from interface: `jakarta.servlet.ServletContext`
Returns a `String` containing the value of the named context-wide initialization parameter, or `null` if the parameter does not exist.

This method can make available configuration information useful to an entire "web application". For example, it can provide a web site administrator's email address or the name of a system that holds critical data.

Specified by:
  `getInitParameter` in interface `ServletContext`
Parameters:
  `name` - a `String` containing the name of the parameter whose value is requested
Returns:
  a `String` containing the value of the initialization parameter
See Also:
  - `ServletConfig.getInitParameter(String)`

### getInitParameterNames

public Enumeration<String> getInitParameterNames()
Description copied from interface: `jakarta.servlet.ServletContext`
Returns the names of the context's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the context has no initialization parameters.

Specified by:
  `getInitParameterNames` in interface `ServletContext`
Returns:
  an `Enumeration` of `String` objects containing the names of the context's initialization parameters
See Also:
  - `ServletConfig.getInitParameter(String)`

### getAttribute

public Object getAttribute(String name)
Description copied from interface: `jakarta.servlet.ServletContext`
Returns the servlet container attribute with the given name, or `null` if there is no attribute by that name. An attribute allows a servlet container to give the servlet additional information not already provided by this interface. See your server documentation for information about its attributes. A list of supported attributes can be retrieved using `getAttributeNames`.

The attribute is returned as a `java.lang.Object` or some subclass. Attribute names should follow the same convention as package names. The Jakarta EE platform reserves names matching `jakarta.*`.

Specified by:
  `getAttribute` in interface `ServletContext`
Parameters:
  `name` - a `String` specifying the name of the attribute
Returns:
  an `Object` containing the value of the attribute, or `null` if no attribute exists matching the given name
See Also:
  - `ServletContext.getAttributeNames()`

### getAttributeNames

public Enumeration<String> getAttributeNames()
Description copied from interface: `jakarta.servlet.ServletContext`
Returns an `Enumeration` containing the attribute names available within this servlet context. Use the `ServletContext.getAttribute(String)` method with an attribute name to get the value of an attribute.

Specified by:
  `getAttributeNames` in interface `ServletContext`
Returns:
  an `Enumeration` of attribute names
See Also:
  - `ServletContext.getAttribute(String)`

### setAttribute

public void setAttribute(String name, Object object)
Description copied from interface: `jakarta.servlet.ServletContext`
Binds an object to a given attribute name in this servlet context. If the name specified is already used for an attribute, this method will replace the attribute with the new to the new attribute.

If listeners are configured on the `ServletContext` the container notifies them accordingly.

If a null value is passed, the effect is the same as calling `removeAttribute()`.

Attribute names should follow the same convention as package names. The Jakarta EE platform reserves names matching `jakarta.*`.

Specified by:
  `setAttribute` in interface `ServletContext`
Parameters:
  `name` - a `String` specifying the name of the attribute
  `object` - an `Object` representing the attribute to be bound

### removeAttribute

public void removeAttribute(String name)
Description copied from interface: `jakarta.servlet.ServletContext`
Removes the attribute with the given name from the servlet context. After removal, subsequent calls to `ServletContext.getAttribute(String)` to retrieve the attribute's value will return `null`.

If listeners are configured on the `ServletContext` the container notifies them accordingly.

Specified by:
  `removeAttribute` in interface `ServletContext`
Parameters:
  `name` - a `String` specifying the name of the attribute to be removed

### getServletContextName

public String getServletContextName()
Description copied from interface: `jakarta.servlet.ServletContext`
Returns the name of this web application corresponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.

Specified by:
  `getServletContextName` in interface `ServletContext`
Returns:
  The name of the web application or null if no name has been declared in the deployment descriptor.

### getContextPath

public String getContextPath()
Description copied from interface: `jakarta.servlet.ServletContext`
Return the main path associated with this context.

Specified by:
  `getContextPath` in interface `ServletContext`
Returns:
  The main context path

### addFilter

public FilterRegistration.Dynamic addFilter(String filterName, String className)
Description copied from interface: `jakarta.servlet.ServletContext`
Add filter to context.

Specified by:
  `addFilter` in interface `ServletContext`
Parameters:
  `filterName` - Name of filter to add
  `className` - Name of filter class
Returns:
  `null` if the filter has already been fully defined, else a `FilterRegistration.Dynamic` object that can be used to further configure the filter

### addFilter

public FilterRegistration.Dynamic addFilter(String filterName, Filter filter)
Description copied from interface: `jakarta.servlet.ServletContext`
Add filter to context.

Specified by:
  `addFilter` in interface `ServletContext`
Parameters:
  `filterName` - Name of filter to add
  `filter` - Filter to add
Returns:
  `null` if the filter has already been fully defined, else a `FilterRegistration.Dynamic` object that can be used to further configure the filter

### addFilter

public FilterRegistration.Dynamic addFilter(String filterName, Class<? extends Filter> filterClass)
Description copied from interface: `jakarta.servlet.ServletContext`
Add filter to context.

Specified by:
  `addFilter` in interface `ServletContext`
Parameters:
  `filterName` - Name of filter to add
  `filterClass` - Class of filter to add
Returns:
  `null` if the filter has already been fully defined, else a `FilterRegistration.Dynamic` object that can be used to further configure the filter

### createFilter

public <T extends Filter> T createFilter(Class<T> c) throws ServletException
Description copied from interface: `jakarta.servlet.ServletContext`
Create a Filter instance using the given class. The instance is just created. No initialisation occurs.

Specified by:
  `createFilter` in interface `ServletContext`
Type Parameters:
  `T` - The type for the given class
Parameters:
  `c` - The the class for which an instance should be created
Returns:
  The created Filter instance.
Throws:
  `ServletException` - If the Filter instance cannot be created

### getFilterRegistration

public FilterRegistration getFilterRegistration(String filterName)
Description copied from interface: `jakarta.servlet.ServletContext`
Returns the `FilterRegistration` for the given filter, or `null` if no such filter exists.

Specified by:
  `getFilterRegistration` in interface `ServletContext`
Parameters:
  `filterName` - The name of the filter for which to return the registration
Returns:
  The `FilterRegistration` for the given filter, or `null` if no such filter exists

### addServlet

public ServletRegistration.Dynamic addServlet(String servletName, String className)
Description copied from interface: `jakarta.servlet.ServletContext`
Register a servlet implementation for use in this ServletContext.

Specified by:
  `addServlet` in interface `ServletContext`
Parameters:
  `servletName` - The name of the servlet to register
  `className` - The implementation class for the servlet
Returns:
  The registration object that enables further configuration

### addServlet

public ServletRegistration.Dynamic addServlet(String servletName, Servlet servlet)
Description copied from interface: `jakarta.servlet.ServletContext`
Register a servlet instance for use in this ServletContext.

Specified by:
  `addServlet` in interface `ServletContext`
Parameters:
  `servletName` - The name of the servlet to register
  `servlet` - The Servlet instance to register
Returns:
  The registration object that enables further configuration

### addServlet

public ServletRegistration.Dynamic addServlet(String servletName, Class<? extends Servlet> servletClass)
Description copied from interface: `jakarta.servlet.ServletContext`
Add servlet to the context.

Specified by:
  `addServlet` in interface `ServletContext`
Parameters:
  `servletName` - Name of servlet to add
  `servletClass` - Class of servlet to add
Returns:
  `null` if the servlet has already been fully defined, else a `ServletRegistration.Dynamic` object that can be used to further configure the servlet

### addJspFile

public ServletRegistration.Dynamic addJspFile(String jspName, String jspFile)
Description copied from interface: `jakarta.servlet.ServletContext`
Add a JSP to the context.

Specified by:
  `addJspFile` in interface `ServletContext`
Parameters:
  `jspName` - The servlet name under which this JSP file should be registered
  `jspFile` - The path, relative to the web application root, for the JSP file to be used for this servlet
Returns:
  a `ServletRegistration.Dynamic` object that can be used to further configure the servlet

### createServlet

public <T extends Servlet> T createServlet(Class<T> c) throws ServletException
Description copied from interface: `jakarta.servlet.ServletContext`
Create an Servlet instance using the given class. The instance is just created. No initialisation occurs.

Specified by:
  `createServlet` in interface `ServletContext`
Type Parameters:
  `T` - The type for the given class
Parameters:
  `c` - The the class for which an instance should be created
Returns:
  The created Servlet instance.
Throws:
  `ServletException` - If the servlet instance cannot be created.

### getServletRegistration

public ServletRegistration getServletRegistration(String servletName)
Description copied from interface: `jakarta.servlet.ServletContext`
Obtain the details of the named servlet.

Specified by:
  `getServletRegistration` in interface `ServletContext`
Parameters:
  `servletName` - The name of the Servlet of interest
Returns:
  The registration details for the named Servlet or `null` if no Servlet has been registered with the given name

### getDefaultSessionTrackingModes

public Set<SessionTrackingMode> getDefaultSessionTrackingModes()
Description copied from interface: `jakarta.servlet.ServletContext`
Obtains the default session tracking modes for this web application. By default `SessionTrackingMode.URL` is always supported, `SessionTrackingMode.COOKIE` is supported unless the `cookies` attribute has been set to `false` for the context and `SessionTrackingMode.SSL` is supported if at least one of the connectors used by this context has the attribute `secure` set to `true`.

Specified by:
  `getDefaultSessionTrackingModes` in interface `ServletContext`
Returns:
  The set of default session tracking modes for this web application

### getEffectiveSessionTrackingModes

public Set<SessionTrackingMode> getEffectiveSessionTrackingModes()
Description copied from interface: `jakarta.servlet.ServletContext`
Obtains the currently enabled session tracking modes for this web application.

Specified by:
  `getEffectiveSessionTrackingModes` in interface `ServletContext`
Returns:
  The value supplied via `ServletContext.setSessionTrackingModes(Set)` if one was previously set, else return the defaults

### getSessionCookieConfig

public SessionCookieConfig getSessionCookieConfig()
Description copied from interface: `jakarta.servlet.ServletContext`
Returns the `SessionCookieConfig` object for this web application, which can be used to configure the session tracking cookie.

Specified by:
  `getSessionCookieConfig` in interface `ServletContext`
Returns:
  The `SessionCookieConfig` object for this web application

### setSessionTrackingModes

public void setSessionTrackingModes(Set<SessionTrackingMode> sessionTrackingModes)
Description copied from interface: `jakarta.servlet.ServletContext`
Configures the available session tracking modes for this web application.

Specified by:
  `setSessionTrackingModes` in interface `ServletContext`
Parameters:
  `sessionTrackingModes` - The session tracking modes to use for this web application

### setInitParameter

public boolean setInitParameter(String name, String value)
Description copied from interface: `jakarta.servlet.ServletContext`
Set the given initialisation parameter to the given value.

Specified by:
  `setInitParameter` in interface `ServletContext`
Parameters:
  `name` - Name of initialisation parameter
  `value` - Value for initialisation parameter
Returns:
  `true` if the call succeeds or `false` if the call fails because an initialisation parameter with the same name has already been set

### addListener

public void addListener(Class<? extends EventListener> listenerClass)
Description copied from interface: `jakarta.servlet.ServletContext`
Adds a listener to this web application. The listener instance will be created by the container using the no-argument constructor of the given class.

Specified by:
  `addListener` in interface `ServletContext`
Parameters:
  `listenerClass` - The class of the listener to add

### addListener

public void addListener(String className)
Description copied from interface: `jakarta.servlet.ServletContext`
Adds a listener to this web application. The listener instance will be created by the container using the no-argument constructor of the given class.

Specified by:
  `addListener` in interface `ServletContext`
Parameters:
  `className` - The fully qualified class name of the listener to add

### addListener

public <T extends EventListener> void addListener(T t)
Description copied from interface: `jakarta.servlet.ServletContext`
Adds the given listener instance to this web application.

Specified by:
  `addListener` in interface `ServletContext`
Type Parameters:
  `T` - The type of listener being added
Parameters:
  `t` - The listener instance to add

### createListener

public <T extends EventListener> T createListener(Class<T> c) throws ServletException
Description copied from interface: `jakarta.servlet.ServletContext`
Creates a new instance of the given listener class, using the web application class loader.

Specified by:
  `createListener` in interface `ServletContext`
Type Parameters:
  `T` - The type of listener being created
Parameters:
  `c` - The class of the listener to create
Returns:
  The new listener instance
Throws:
  `ServletException` - If the listener cannot be instantiated, e.g., if the class does not have a no-argument constructor, or if instantiation fails for any other reason

### declareRoles

public void declareRoles(String... roleNames)
Description copied from interface: `jakarta.servlet.ServletContext`
Add to the declared roles for this ServletContext.

Specified by:
  `declareRoles` in interface `ServletContext`
Parameters:
  `roleNames` - The roles to add

### getClassLoader

public ClassLoader getClassLoader()
Description copied from interface: `jakarta.servlet.ServletContext`
Get the web application class loader associated with this ServletContext.

Specified by:
  `getClassLoader` in interface `ServletContext`
Returns:
  The associated web application class loader

### getEffectiveMajorVersion

public int getEffectiveMajorVersion()
Description copied from interface: `jakarta.servlet.ServletContext`
Obtain the major version of the servlet specification for which this web application is implemented.

Specified by:
  `getEffectiveMajorVersion` in interface `ServletContext`
Returns:
  The major version declared in web.xml

### getEffectiveMinorVersion

public int getEffectiveMinorVersion()
Description copied from interface: `jakarta.servlet.ServletContext`
Obtain the minor version of the servlet specification for which this web application is implemented.

Specified by:
  `getEffectiveMinorVersion` in interface `ServletContext`
Returns:
  The minor version declared in web.xml

### getFilterRegistrations

public Map<String, ? extends FilterRegistration> getFilterRegistrations()
Description copied from interface: `jakarta.servlet.ServletContext`
Returns an immutable Map of all the filter registrations for this web application, where the key is the filter name and the value is the `FilterRegistration` object.

Specified by:
  `getFilterRegistrations` in interface `ServletContext`
Returns:
  An immutable Map of all the filter registrations for this web application

### getJspConfigDescriptor

public JspConfigDescriptor getJspConfigDescriptor()
Description copied from interface: `jakarta.servlet.ServletContext`
Returns the `JspConfigDescriptor` for this web application, which provides access to the JSP configuration elements such as taglib and jsp-property-group declarations.

Specified by:
  `getJspConfigDescriptor` in interface `ServletContext`
Returns:
  The `JspConfigDescriptor` for this web application

### getServletRegistrations

public Map<String, ? extends ServletRegistration> getServletRegistrations()
Description copied from interface: `jakarta.servlet.ServletContext`
Obtain a Map of servlet names to servlet registrations for all servlets registered with this context.

Specified by:
  `getServletRegistrations` in interface `ServletContext`
Returns:
  A Map of servlet names to servlet registrations for all servlets registered with this context

### getVirtualServerName

public String getVirtualServerName()
Description copied from interface: `jakarta.servlet.ServletContext`
Get the primary name of the virtual host on which this context is deployed. The name may or may not be a valid host name.

Specified by:
  `getVirtualServerName` in interface `ServletContext`
Returns:
  The primary name of the virtual host on which this context is deployed

### getSessionTimeout

public int getSessionTimeout()
Description copied from interface: `jakarta.servlet.ServletContext`
Get the default session timeout.

Specified by:
  `getSessionTimeout` in interface `ServletContext`
Returns:
  The current default session timeout in minutes

### setSessionTimeout

public void setSessionTimeout(int sessionTimeout)
Description copied from interface: `jakarta.servlet.ServletContext`
Set the default session timeout. This method may only be called before the ServletContext is initialised.

Specified by:
  `setSessionTimeout` in interface `ServletContext`
Parameters:
  `sessionTimeout` - The new default session timeout in minutes.

### getRequestCharacterEncoding

public String getRequestCharacterEncoding()
Description copied from interface: `jakarta.servlet.ServletContext`
Get the default character encoding for reading request bodies.

Specified by:
  `getRequestCharacterEncoding` in interface `ServletContext`
Returns:
  The character encoding name or `null` if no default has been specified

### setRequestCharacterEncoding

public void setRequestCharacterEncoding(String encoding)
Description copied from interface: `jakarta.servlet.ServletContext`
Set the default character encoding to use for reading request bodies. Calling this method will over-ride any value set in the deployment descriptor.

Specified by:
  `setRequestCharacterEncoding` in interface `ServletContext`
Parameters:
  `encoding` - The name of the character encoding to use

### getResponseCharacterEncoding

public String getResponseCharacterEncoding()
Description copied from interface: `jakarta.servlet.ServletContext`
Get the default character encoding for writing response bodies.

Specified by:
  `getResponseCharacterEncoding` in interface `ServletContext`
Returns:
  The character encoding name or `null` if no default has been specified

### setResponseCharacterEncoding

public void setResponseCharacterEncoding(String encoding)
Description copied from interface: `jakarta.servlet.ServletContext`
Set the default character encoding to use for writing response bodies. Calling this method will over-ride any value set in the deployment descriptor.

Specified by:
  `setResponseCharacterEncoding` in interface `ServletContext`
Parameters:
  `encoding` - The name of the character encoding to use